﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.Windows.Media.Animation;

namespace High_density_scatter_WPF
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        public MainWindow()
        {
            InitializeComponent();
            //create the data set and set it as context for the chart
            var data = new ScatterDataCollection(300000);
            this.xamDataChart.DataContext = data;
        }

        private void HighDensityScatterSeries_ProgressiveLoadStatusChanged(object sender, Infragistics.Controls.Charts.ProgressiveLoadStatusEventArgs e)
        {
            // use the status to scale the rectangle's width as percentage of the parent border
            this.bar.Width = (this.border.ActualWidth / 100) * e.CurrentStatus;
            // and display the status as text too
            this.status.Text = e.CurrentStatus + " %";
            // add small slide-up animation when the loading is finished
            if (e.CurrentStatus == 100)
            {
                DoubleAnimation animation = new DoubleAnimation();
                //manipulate the border's height to 0
                animation.From = this.border.Height;
                animation.To = 0;
                animation.Duration = new Duration(new TimeSpan(0, 0, 0, 1));
                Storyboard sb = new Storyboard();
                sb.Children.Add(animation);
                Storyboard.SetTarget(animation, border);
                Storyboard.SetTargetProperty(animation, new PropertyPath("Height"));
                sb.Begin();
            }
        }
    }

    /// <summary>
    /// The data collection we would use with a contructor to manipulate the data size.
    /// </summary>
    public class ScatterDataCollection : ObservableCollection<ScatterDataPoint>
    {
        public ScatterDataCollection(int count)
        {
            Random random = new Random();
            this.Clear();
            for (int i = 0; i < count; i++)
            {
                double x = random.Next(random.Next(1000));
                double y = random.Next(random.Next(1000));
                this.Add(new ScatterDataPoint { X = x, Y = y });
            }
        }
    }

    /// <summary>
    /// A very basic (lightweight) point class
    /// </summary>
    public class ScatterDataPoint
    {
        public double X { get; set; }
        public double Y { get; set; }
    }
}
